<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

include( dirname(dirname(__FILE__)) . '/poll/index.inc.php' );

class CTClassApp extends CTClassObject {

	public function setup( $sys ) {

		if ( !parent::setup( $sys ) ) { return false; }

		//-- setup poll & poll items
		$this->poll = new CPoll( $sys, $this );
		$this->poll->attr( "data-conn", "std" );
		if ( !$this->setupPoll( $this->poll ) ) { return false; }
		if ( !$this->poll->setup() ) { return false; }

		//-- cmdpsec
		$this->cmdspec = array();
		if ( !$this->setupCmdSpec( $this->cmdspec ) ) { return false; }

		return true;
	}

	public function setupCmdSpec( &$cmdspec ) {

		parent::setupCmdSpec( $cmdspec );

		if ( $this->poll->ended() ) {
			$cmdspec["init"] = "result";
		} else {
			$cmdspec["init"] = "front";
		}

		$cmdspec["front"] = array(
			"@hd_front",
			"tpl.front.inc.php",
			"js.front.inc.php",
		);

		$cmdspec["result"] = array(
			"@hd_result",
			"tpl.result.inc.php",
			"js.result.inc.php",
		);

		$cmdspec["vote"] = array(
			"@hd_vote",
			"tpl.result.inc.php",
			"js.result.inc.php",
		);

		$cmdspec["clear_block"] = array(
			"@hd_clear_block",
		);

		return true;
	}

	public function addStyle( $style ) {
		$style = str_replace( "\r", "\\r", $style );
		$style = str_replace( "\n", "\\n", $style );
		$style = str_replace( "\"", "\\\"", $style );

		$style = str_replace( "%tclass%", $this->sys->tclass, $style );

		$s = "";
		$s .= "<script>(function(\$){";
		$s .= "\$('head').append( \"{$style}\" );";
		$s .= "}(jQueryX));</script>";
		echo $s;
	}

	public function hd_front( &$ret ) {
		return true;
	}

	public function hd_result( &$ret ) {
		return $this->poll->load( $ret, false);
	}

	public function hd_vote( &$ret ) {
		return $this->poll->load( $ret, true );
	}

	public function hd_clear_block( &$ret ) {
		return $this->poll->clear_block( $ret );
	}

}

?>