<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CCookieBlock {

	private static function getMaxCookieExpTime() {
		if ( PHP_INT_SIZE == 4 ) {// 32 bits PHP
			//-- 2147483647 = 2^31-1 = 2038-01-18 19:14:07
			return 2147483647;
		} else {// 64 bits PHP
			//-- 10 years
			return time() + (10 * 365 * 24 * 60 * 60);
		}
	}

	public function setup( $cookie_key ) {
		//-- cookie name must not contain '.'
		$cookie_key = str_replace( '.', '-', $cookie_key );

		$this->cookie_key = $cookie_key;
		$this->period = self::getMaxCookieExpTime();
	}

	public function add( $val = 'yes' ) {
		setcookie( $this->cookie_key, $val, $this->period );
		$_COOKIE[$this->cookie_key] = $val;
		return true;
	}

	public function get() {
		if ( isset($_COOKIE[$this->cookie_key]) ) {
			return $_COOKIE[$this->cookie_key];
		} else {
			return '';
		}
	}

	public function exists() {
		return ( isset($_COOKIE[$this->cookie_key]) );
	}

//	public function validate() {
//		if ( $this->exists() ) {
//			return false;
//		} else {
//			return true;
//		}
//	}

	public function clear() {
		setcookie( $this->cookie_key, "", time()-3600 );
		return true;
	}
}

?>