<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CPollItem {

	public function setup( $sys, $prt, $key, $cap ) {

		//-- pointers
		$this->sys =& $sys;
		$this->prt =& $prt;
		$this->key = $key;
		$this->cap = $cap;

		//-- attributes
		$this->_attr_ = array();

		//-- count
		$this->cnt = 0;
	}

	public function attr( $key, $val = null ) {
		if ( is_null( $val ) ) {
			if ( isset( $this->_attr_[$key] ) ) {
				return $this->_attr_[$key];
			} else {
				return null;
			}
		} else {
			$this->_attr_[$key] = $val;
		}
	}

	public function getKey() {
		return $this->key;
	}

	public function getCaption() {
		return $this->cap;
	}

	public function getCount() {
		return $this->cnt;
	}

	public function getPercent( $precision = 0 ) {
		$total = $this->prt->getTotal();
		if ( $total == 0 ) {
			$v = 0;
		} else {
			$v = ( 100 * $this->getCount() ) / $total;
		}
		$v = round( $v, $precision );
		$v = sprintf( "%01.{$precision}f", $v );
		return $v;
	}

	public function getWRatio() {
		$max_count = $this->prt->getMaxCount();
		if ( $max_count == 0 ) { return 0; }
		return round( $this->getCount() / $max_count, 2 );
	}

	public function isVoted() {
		return $this->prt->hasVoted( $this->getKey() );
	}

	public function setCount( $cnt ) {
		if ( !$this->isInteger( $cnt ) ) { $cnt = 0; }
		$this->cnt = intval( $cnt );
	}

	public function incCount( $d = 1 ) {
		$this->cnt += $d;
	}

	public function isInteger( $v ) {
		if ( strlen( $v ) == 0 ) { return false; }
		if ( !is_numeric( $v ) ) { return false; }
		if ( doubleval( $v ) - intval( $v ) != 0 ) { return false; }
		return true;
	}

}

?>