<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CJson {

	public static function dqstr( $txt ) {
		$txt = str_replace( "\\", "\\\\", $txt );
		$txt = str_replace( "\r", "\\r", $txt );
		$txt = str_replace( "\n", "\\n", $txt );
		$txt = str_replace( "\"", "\\\"", $txt );
		return $txt;
	}

	//----------------------------------------------------------------
	// encode
	//
	// type:
	//   '' : associative array
	//   @  : non-associative array
	//   -  : direct json string ( e.g. '{ "a":"aaa", "b":"bbb" }' )
	//----------------------------------------------------------------
	public static function encode( &$data, $type = '' ) {
		if ( $type == '-' ) {
			return $data;
		}

		$ax = array();
		foreach( $data as $key => $val ) {

			$type2 = ( substr($key,0,1) );
			switch( $type2 ) {
			case "@":
			case "-":
				$key = substr($key,1);
				break;
			default:
				$type2 = '';
				break;
			}

			if ( $type == '' ) {
				$s = "\"{$key}\":";
			} else {
				$s = "";
			}

			if ( is_array( $val ) ) {
				$s .= CJson::encode( $val, $type2 );
			} elseif ( $type2 == '-' ) {
				$s .= $val;
			} else {
				$s .= '"' . CJson::dqstr( $val ) . '"';
			}

			$ax[] = $s;
		}

		$s = implode( ",", $ax );
		if ( $type == '' ) {
			$s = "{" . $s . "}";
		} else {
			$s = "[" . $s . "]";
		}

		return $s;
	}

	public static function decode( $json ) {
		return json_decode( $json, true );
	}
}

?>