<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CTClassObject {

	public function setup( $sys ) {
		$this->sys =& $sys;

		return true;
	}

	public function setupCmdSpec( &$cmdspec ) {
	}

	public function processCmdSpec( &$spec, &$ret ) {

		foreach( $spec as $cmd ) {
			if ( substr( $cmd, 0, 1 ) == '@' ) {
				$cmd = substr( $cmd, 1 );

				if ( method_exists( $this, $cmd ) ) {
					if ( !call_user_func_array( array( $this, $cmd ), array( &$ret ) ) ) {
						break;
					}
				} else {
					$this->sys->showErrorMsg( "method does not exist ({$cmd})" );
					return false;
				}
			} else {
				$path1 = $this->sys->path_tclass . $cmd;
				if ( file_exists( $path1 ) ) {
					include( $path1 );
				} else {
					$path2 = $this->sys->path_base_tclass . $cmd;
					if ( file_exists( $path2 ) ) {
						include( $path2 );
					} else {
						$this->sys->showErrorMsg(
							"file does not exist ({$path1}), ({$path2})" );
						return false;
					}
				}
			}
		}

		return true;
	}

	public function run( $sys ) {
		ob_start();

		if ( !$this->setup( $sys ) ) { return false; }

		//-- run the requested command
		$this->appid = $_REQUEST['appid'];
		$this->cmd = $_REQUEST['cmd'];

		$this->result = "OK";
		$ret = array();

		if (  array_key_exists( $this->cmd, $this->cmdspec ) ) {
			$ret["cmd"] = "load";

			//-- get command spec
			$spec = $this->cmdspec[$this->cmd];

			//-- command redirection
			if ( !is_array( $spec ) ) {
				$spec = $this->cmdspec[$spec];
			}

			$this->processCmdSpec( $spec, $ret );
		} else {
			$ret["cmd"] = "alert";
			echo "Unknown Command [{$this->cmd}]";
		}

		$ret["html"] = ob_get_contents();
		ob_end_clean();
		$ret["result"] = $this->result;

		CTClassSys::sendRet( $ret );

		return true;
	}
}

?>