<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CTClassSys {

	public static $cfg_params = array();

	public static function sendRet( $ret ) {
//		echo CJson::encode( $ret );
		echo $_GET['callback'] . "(" . CJson::encode( $ret ) . ");";
	}

	public static function getConfigPath() {
		return self::$cfg_params['path-config'];
	}

	public static function getLangPath() {
		$path = self::$cfg_params['path-locale'];
		if ( !empty( self::$cfg_params['lang-code'] ) ) {
			$path .= self::$cfg_params['lang-code'] . '/';
		}
		return $path;
	}

	public static function loadConfig( $name, &$_cfg ) {
		include( self::getConfigPath() .
			"config.{$name}.inc.php" );
	}

	public static function loadLang( $name, &$_lng ) {
		include( self::getLangPath() .
			"locale.{$name}.inc.php" );
	}

	public function getTClassName() {
		return $this->tclass;
	}

	public function getIdName() {
		return $this->tclass . '.' . $this->tid;
	}

	public function getFolderUrl() {
		return $this->url_app_root . "polls/" . $this->tclass . '/';
	}

	public function getAppDataPath() {
		return $this->path_app_data;
	}

	public function setupDataFolder( $path ) {

		//-- check app data folder
		$path_appdata = $this->getAppDataPath();
		if ( !$this->checkPermission( "rw", $path_appdata ) ) {
			return false;
		}

		//-- tclass data folder exists?
		if ( !file_exists( $path ) ) {
			@mkdir( $path );
			@chmod( $path, 0777 );
			if ( !file_exists( $path ) ) {
				$err_msg = "Can not create a folder in [tdata]";
				$this->showErrorMsg( $err_msg );
				return false;
			}
		}

		return true;
	}

	public function fatalError( $msg ) {
		$ret = array( "result" => $msg );
		self::sendRet( $ret );
		exit;
	}

	public function showErrorMsg( $err_msg ) {

		if ( is_array( $err_msg ) ) {
			$err_msg = implode( "<br/>", $err_msg );
		}

		$msg = '';
		$msg .= "<!--(ERRBOX)-->";
		$msg .= "<div style='padding:0px;border:1px solid red;";
		$msg .= "background-color:#fff0f0;'>";
		$msg .= "<div style='color:white;font-size:80%;font-weight:bold;";
		$msg .= "background-color:#ff0000;'>ERROR</div>";
		$msg .= "<div style='padding:10px;'>";
		$msg .= $err_msg;
		$msg .= "</div>";
		$msg .= "</div>";
		echo $msg;

	}

	public function checkPermission( $ptype, $path ) {

		$msg = array();

		if ( strpos( $ptype, 'r' ) !== false ) {
			if ( !is_readable( $path ) ) {
				self::loadLang("app.requirements",$lng);
				$msg[] = $lng[ 'err:cannot-read' ] . " [{$path}]";
			}
		}

		if ( strpos( $ptype, 'w' ) !== false ) {
			if ( !is_writeable( $path ) ) {
				self::loadLang("app.requirements",$lng);
				$msg[] = $lng[ 'err:cannot-write' ] . " [{$path}]";
			}
		}

		$b_success = ( count( $msg ) == 0 );

		if ( !$b_success ) {
			$this->showErrorMsg( $msg );
		}

		return $b_success;
	}

	public function getThisPageURL() {
		$http = true;
		$url = "";

		if ( $http ) {
			$url .= "http";

			$b_https = (( isset( $_SERVER["HTTPS"] ) ) && ( $_SERVER["HTTPS"] == "on" ));
			if ( $b_https ) {
				$url .= "s";
			}

			$url .= "://" . $_SERVER["SERVER_NAME"];

			if (( $_SERVER["SERVER_PORT"] != "80" ) && !$b_https ) {
				$url .= ":" . $_SERVER["SERVER_PORT"];
			}
		}

		//-- $_SERVER["SCRIPT_NAME"] trancates GET params and PathInfo.
		$url .= $_SERVER["SCRIPT_NAME"];

		return $url;
	}

	private static function sanitizeFilename( $str ) {
		$str = substr( $str, 0, 255 );

		$res = '';
		$len = strlen( $str );
		for( $i = 0; $i < $len; $i++ ) {
			$ch = mb_substr( $str, $i, 1 );
			if (
				ctype_alnum( $ch ) ||
				( $ch == '_' ) ||
				( $ch == '-' )
			) {
				$res .= $ch;
			} else {
				$res .= '-';
			}
		}
		return $res;
	}

	public function loadTClassFile( $fn ) {
		$path1 = $this->path_tclass . $fn;
		if ( file_exists( $path1 ) ) {
			$path = $path1;
		} else {
			$path2 = $this->path_base_tclass . $fn;
			if ( file_exists( $path2 ) ) {
				$path = $path2;
			} else {
				$this->fatalError( "file ({$fn}) does not exist{$path1}" );
			}
		}
		include( $path );
	}

	public function run() {

		//-- path
		$this->path_app_root = dirname(dirname(dirname(__FILE__))) . '/';

		//-- load configurations
		$_cfg =& self::$cfg_params;
		require( $this->path_app_root . 'config/config.env.inc.php' );

		//-- url
		$this->url_app_entry = $this->getThisPageURL();
		$this->url_app_root = dirname($this->url_app_entry) . '/';

		$this->url_app_img = $this->url_app_root . 'wres/img' . '/';

		//-- js params
		$this->app_object_selector = ".ajax-poll";
		$this->app_init_cmd = "init";

		//-- run
		if ( isset( $_REQUEST['cmd'] ) ) {

			//-- tclass name
			if ( isset( $_REQUEST['tclass'] ) && !empty( $_REQUEST['tclass'] ) ) {
				$this->tclass = $this->sanitizeFilename( $_REQUEST['tclass'] );
			} else {
				$this->tclass = 'tclass-not-found';
			}

			//-- tid name
			if ( isset( $_REQUEST['tid'] ) && !empty( $_REQUEST['tid'] ) ) {
				$this->tid = $this->sanitizeFilename( $_REQUEST['tid'] );
			} else {
				$this->tid = 'def';
			}

			//-- app.data path
			$this->path_app_data = $_cfg['path-data'];

			//-- tclass path
			$this->path_tclass = $this->path_app_root . "polls/" . $this->tclass . "/"; 

			//-- base tclass path
			$this->path_base_tclass = $this->path_app_root . "lib/base-tclass/"; 

			//-- load CTClassApp
			$this->loadTClassFile( "class-app.inc.php" ); 

			//-- load CTClassBase
			$this->loadTClassFile( "class-base.inc.php" ); 

			//-- load CTClass
			$this->loadTClassFile( "config.inc.php" ); 

			//-- start-up
			$obj = new CTConfig();
			$obj->run( $this );

		} else {
			header('Content-Type: application/javascript');
			include( dirname(__FILE__) . '/tclass.js.inc.php' );
		}
	}
}

?>