<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax簡易投票所 v3.25 [ GPL ]
// Copyright (c) phpkobo.com ( http://jpn.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : APSMX-325J
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
?>
(function($){

//----------------------------------------------------------------
// CWaitIcon
//----------------------------------------------------------------
function CWaitIcon( url_img ) {
	var s = '';
	s += "<img ";
	s += "src='" + url_img + "'";
	s += ">";
	this.img = $( s );

	this.img.css({
		"position":"absolute",
		"left":"-10000px",
		"top":"-10000px"
	});

	this.img.hide();
	this.img.appendTo( $( 'body' ) );
}

CWaitIcon.prototype = {

	show : function( e ) {
		var _this = this;

		this.b_show = true;
		setTimeout(function(){
			if ( _this.b_show ) {
				var w = 32;
				var h = 32;
				_this.img
					.css({
						"left":(e.pageX - w/2) + "px",
						"top":(e.pageY - h/2) + "px"
					})
					.show();
			}
		},300);
	},

	hide : function() {
		this.b_show = false;
		this.img.hide();
	}
}

//----------------------------------------------------------------
// CApp
//----------------------------------------------------------------
var app_object_selector = '<?php echo $this->app_object_selector; ?>';

function CApp( jobj ) {
	this.children = [];

	this.jobj = jobj;
	this.tclass = this.getAttr( 'tclass', jobj );
	this.tid = this.getAttr( 'tid', jobj );
	this.url_app_entry = '<?php echo $this->url_app_entry; ?>';
	this.url_app_root = '<?php echo $this->url_app_root; ?>';
	this.url_app_img = '<?php echo $this->url_app_img; ?>';
	this.appid = this.makeRandomString( 64 );
	this.app_init_cmd = '<?php echo $this->app_init_cmd; ?>'; 
	this.wait_icon = new CWaitIcon( this.url_app_img + 'wait.gif' );
	this.tipbox = null;
	if ( this.app_init_cmd != '' ) {
		this.send( { "cmd" : this.app_init_cmd } );
	}
}

CApp.prototype = {

	showWaitIcon: function( e ) {
		this.wait_icon.show( e );
	},

	showTipBox: function( obj, cfg ) {
		var _this = this;

		//-- tipbox timer id
		if ( "tipbox_timer" in this ) {
			if ( this.tipbox_timer != -1 ) {
				clearTimeout(this.tipbox_timer);
			}
		}
		this.tipbox_timer = -1;
		this.hideTipBox();

		//-- tipbox
		this.tipbox = obj.parents('.poll-'+this.tclass).find(
			'.poll-'+this.tclass+'-tipbox-'+cfg['class']);
		this.tipbox.stop(true,true)
		this.tipbox.html(cfg["txt"]);
		if ( "background-color" in cfg ) {
			this.tipbox.css({
				"background-color":cfg['background-color']
			});
		}
		this.tipbox.show();

		//-- animate
		wt = this.tipbox.outerWidth(false);
		ht = this.tipbox.outerHeight(true);

		var x = obj.offset().left;
		var y = obj.offset().top;
		var w = obj.width();
		var h = obj.height();

		var ytd = 10;
		var xt = x + w/2 - wt/2;
		var yt = y - ht;

		var xm = 0;
		var ym = 30;

		var period = ( "period" in cfg ) ? cfg["period"] : 2500;

		var opa = this.tipbox.css("opacity");
		this.tipbox
			.offset({left:(xt - xm),top:(yt - ym)})
			.css({
				"opacity":0
			})
			.animate({
				"left": "+=" + xm + "px",
				"top": "+=" + ym + "px",
				"opacity":"+=" + opa
			}, 300, function(){
				_this.tipbox_timer = setTimeout(function(){
					_this.tipbox.fadeOut( 500, function() {
						_this.hideTipBox();
					});
				},period);
			});
	},

	hideTipBox: function() {
		if ( this.tipbox != null ) {
			this.tipbox.hide();
		}
	},

	makeRandomString : function ( n ) {
		var s = "";
		var src = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
		for ( var i=0; i < n; i++ ) {
			s += src.charAt( Math.floor( Math.random() * src.length ) );
		}
		return s;
	},

	errBox : function( data ) {

		var errbox_sig = "<!--(ERRBOX)-->";
		if ( data.substring( 0, errbox_sig.length ) == errbox_sig ) {
			// prevent double errbox
			return data;
		} else {
			var msg = '';
			msg += "<div style='padding:0px;border:1px solid red;";
			msg += "background-color:#fff0f0;'>";
			msg += "<div style='color:white;font-size:80%;font-weight:bold;";
			msg += "background-color:#ff0000;'>ERROR</div>";
			msg += "<div style='padding:10px;'>";
			msg += data;
			msg += "</div>";
			msg += "</div>";
			return msg;
		}
	},

	getAttr : function( id_name, jobj ) {
		if (
			( typeof( jobj.attr( id_name ) ) == 'undefined' ) || 
			( jobj.attr( id_name ) == '' ) // for Opera
		) return '';
		return jobj.attr( id_name );
	},

	send : function( json ) {
		json['appid'] = this.appid;
		json['tclass'] = this.tclass;
		json['tid'] = this.tid;

		var _this = this;
/*
		$.post( this.url_app_entry,
			json,
			function(data) {
				_this.process(data);
		});
*/
		$.ajax({
			url:this.url_app_entry,
			data:json,
			dataType: 'jsonp',
			success:function(json){
				_this.process(json);
			},
			error:function( jqXHR, textStatus, errorThrown ){
				var s = '[ajax error]\n';
				s += jqXHR.responseText+'\n';
				s += textStatus+'\n';
				s += errorThrown;
				console.log(s);
			}
		});

	},

	addChild : function( child ) {
		this.children[child.name] = child;
		return child;
	},

	getChild : function( name ) {
		return this.children[name];
	},

	sendMsg : function( msg ) {
		if ( typeof( msg.receiver ) !== 'undefined' ) {
			if( Object.prototype.toString.call( msg.receiver ) === '[object Array]' ) {
				for ( var i = 0; i < msg.receiver.length; i++ ) {
					var ret = this.children[ msg.receiver[i] ].msgProc( msg );
					if ( ret != 0 ) return ret;
				}
			} else {
				return this.children[msg.receiver].msgProc( msg );
			}
		} else {
			for( name in this.children ) {
				var ret = this.children[name].msgProc( msg );
				if ( ret != 0 ) { return ret; }
			}
		}
	},

	process : function( data ) {

		this.wait_icon.hide();

		this.res = data;

		try {
			if ( this.res.result == 'OK' ) {
				window[this.appid] = this;
				switch( this.res.cmd ) {
				case "alert":
					alert(this.res.html);
					break;
				case "load":
					window.jQueryX = $;
					this.jobj.append( this.res.html );
					break;
				}

				if ( typeof( this.res.msg ) !== 'undefined' ) {
					this.sendMsg( this.res.msg );
				}
			} else {
				//-- code error
				alert( "^" + this.res.result );
				this.jobj.html( this.res.result );
			}
		} catch(e) {
			var msg = "{ERROR}:" + e.message;
			alert( msg );
		}
	}
}

$(document).ready(function() {
	if (!( 'ajax-poll-script-9009' in window )) {
		window['ajax-poll-script-9009'] = true;
		$( app_object_selector ).each( function(){
			var app = new CApp( $(this) ); 
		});
	}
});

}(jQuery));
<?php /* -- END OF FILE -- */ ?>